#include <stdio.h>
#include <xil_exception.h>
#include <xparameters.h>
#include "platform.h"
#include "xbasic_types.h"
#include "xiomodule.h"
#define IOBUS_REG_OFFSET 0x0
#define LED34 (*(volatile u32 *) ( XPAR_IOMODULE_0_IO_BASEADDR + IOBUS_REG_OFFSET))
int pit_cnt=0; ;

u32 uDevId = XPAR_IOMODULE_0_DEVICE_ID;
u32 uGpioCha = 1;
XIOModule mcsIOMdule;
int lp;
//K
int tone_array[9]={0x0,0x1a7,0x179,0x150,0x13d,0x11a,0xfb,0xe0,0xd3};
//JG̍@yf[^
char music_array[256]={1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,3,3,3,3,2,2,2,2,1,1,1,1,0,0,0,0,
		              3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6,5,5,5,5,4,4,4,4,3,3,3,3,0,0,0,0,
		              1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,
		              1,0,1,0,2,0,2,0,3,0,3,0,4,0,4,0,3,3,0,0,2,2,0,0,1,1,0,0,0,0,0,0,
		              0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		              0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

void print(char *str);

void wr_func(int adr,int wdata){
	  XIOModule_DiscreteWrite(&mcsIOMdule, 1, (0x700 | adr));
	  XIOModule_DiscreteWrite(&mcsIOMdule, 1, adr);
	  XIOModule_DiscreteWrite(&mcsIOMdule, 1, (0x600 | adr));
	  XIOModule_DiscreteWrite(&mcsIOMdule, 1, (0x700 | wdata));
	  XIOModule_DiscreteWrite(&mcsIOMdule, 1, (0x100 | wdata));
	  XIOModule_DiscreteWrite(&mcsIOMdule, 1, (0x700 | wdata));
}

void set_tone(u32 reg_num,int num){
	int tone;
    tone=tone_array[(int)music_array[num]];
    xil_printf("m1 tone = %d \n\r",tone);
    wr_func( reg_num,(tone&0xff));
    wr_func( reg_num+1,(tone>>8));
}

void PIT_ISR( void ){
	set_tone(0,pit_cnt);
	if(pit_cnt<32)
	  lp = 160 + pit_cnt;
	else
	  lp = pit_cnt - 32;
	set_tone(2,lp);
	if(pit_cnt<64)
	  lp = 128 + pit_cnt;
	else
	  lp = pit_cnt - 64;
	set_tone(4,lp);
	//LED
	if (0x1 & pit_cnt)
      XIOModule_DiscreteWrite(&mcsIOMdule,uGpioCha, 0x80000000);
	else
	  XIOModule_DiscreteWrite(&mcsIOMdule,uGpioCha, 0x0);
	if(pit_cnt>192)
	  pit_cnt = 0;
	else
	  pit_cnt++;
}

int main()
{
u8  uIntrId_pit =  XIN_IOMODULE_PIT_1_INTERRUPT_INTR ;
u8  Timer_num = 0;
init_platform();
XIOModule_Initialize(&mcsIOMdule, uDevId);
XIOModule_DiscreteWrite(&mcsIOMdule, 1, 0x0600);
//volume
wr_func(0xa,0xd);//wr r10
microblaze_register_handler(XIOModule_DeviceInterruptHandler, uDevId);
XIOModule_Start(&mcsIOMdule);
//Timer handler
XIOModule_Connect(&mcsIOMdule, uIntrId_pit, PIT_ISR, NULL);
//Timer
XIOModule_SetResetValue(&mcsIOMdule,Timer_num, 5000000);
XIOModule_Timer_SetOptions(&mcsIOMdule, Timer_num,  XTC_AUTO_RELOAD_OPTION);
XIOModule_Timer_Start(&mcsIOMdule,Timer_num);
XIOModule_Enable(&mcsIOMdule, uIntrId_pit);
microblaze_enable_interrupts();
while(1);
return 0;
}

