`timescale 1ns / 1ps
//*****************************************************************************
// File Name            : sqm_mb_mcs.v
//-----------------------------------------------------------------------------
// Function             : sqm_mb_mcs top
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2013/01/10 
//*****************************************************************************
module sqm_mb_mcs(
    input clk,
    input rst,
	input UART_Rx,
	output UART_Tx,
    output led,
    output y,
	 output a_c
    );
	 
	 wire [31:0] GPO1;
	 wire [3:0] A;
	 wire [3:0] B;
	 wire [3:0] C;

    wire rst;
    wire Reset;
    wire Reset_n;
	wire clk_50m;
	wire sound_clk;
    wire LOCKED;

assign rst_n = ~rst;

  clk_gen clk_gen
   (// Clock in ports
    .CLK_IN1(clk),      // IN 100NHz
    // Clock out ports
    .CLK_OUT1(clk_50m),     // OUT 50MHz
    .CLK_OUT2(sound_clk),     // OUT 3.571MHz
    // Status and control signals
    .RESET(rst),// IN
    .LOCKED(LOCKED));      // OUT
	 
assign Reset =((rst==1'b1)||(LOCKED==1'b0))?1'b1:1'b0;
assign Reset_n = ~Reset;	 
assign a_c = sound_clk;

mb_mcs mcs_0 (
  .Clk(clk_50m), // input Clk
  .Reset(Reset), // input Reset
  .UART_Rx(UART_Rx), // input UART_Rx
  .UART_Tx(UART_Tx), // output UART_Tx
  .GPO1(GPO1) // output [31 : 0] GPO1
);
 
//PSG
AY_3_8910_capcom 
#(1,0) 
ay( .reset_n( Reset_n), .clk(clk_50m), // CPU clock
     .sound_clk(sound_clk), // normally slower than the CPU clock
     .din(GPO1[7:0]), .adr(GPO1[8]), .cs_n( GPO1[9]), .wr_n( GPO1[10]),
     .A(A),.B(B),.C(C) // channel outputs
);
//PWM
da_e_pwm pwm (
	.clk(clk_50m), 
	.reset_n(Reset_n), 
	.din_a(A),.din_b(B),.din_c(C), 
	.pwm(y)
	);
//LED
assign led = GPO1[31];

endmodule
